<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'GradientPill',
  props: {
    text: {
      type: String,
      required: true,
    },
    button: {
      type: Object,
      required: false,
      default: null,
    },
    gradient: {
      type: String,
      required: false,
      default:
        'linear-gradient(89.09deg, #e1986d -1.12%, #7759c2 102.06%, #6e43d3 102.07%)',
    },
    icon: {
      type: Object,
      required: false,
      default: null,
    },
  },
});
</script>

<template>
  <a
    v-if="button"
    class="eyebrow"
    :href="button.href"
    :data-ga-name="button.data_ga_name"
    :data-ga-location="button.data_ga_location"
    :style="{ '--background-gradient': gradient }"
  >
    <img
      v-if="!icon"
      class="left-column"
      src="/nuxt-images/solutions/ai/icons/eyebrow-two.svg"
      alt=""
    />
    <SlpIcon
      v-else
      :variant="icon.variant"
      :name="icon.name"
      class="left-column"
    />
    <SlpTypography variant="body3-bold" tag="span" class="top-row">
      {{ text }}
    </SlpTypography>
    <button v-if="button.text" variant="tertiary" class="bottom-row">
      {{ button.text }}
    </button>
  </a>
  <div v-else class="eyebrow">
    <img
      v-if="!icon"
      src="/nuxt-images/solutions/ai/icons/eyebrow-one.svg"
      alt=""
    />
    <SlpIcon v-else :variant="icon.variant" :name="icon.name" />
    <SlpTypography variant="body3-bold" tag="span">
      {{ text }}
    </SlpTypography>

    <SlpButton
      v-if="button"
      :href="button.href"
      :data-ga-name="button.data_ga_name"
      :data-ga-location="button.data_ga_location"
      variant="tertiary"
    >
      {{ button.text }}
    </SlpButton>
  </div>
</template>

<style lang="scss" scoped>
.eyebrow {
  display: grid;
  grid-template-columns: 16px 1fr;
  grid-template-rows: auto auto;
  grid-template-areas:
    'left-column top-row'
    'left-column bottom-row';
  margin-bottom: 16px;
  position: relative;
  padding: 8px 12px;
  color: $color-text-300;
  font-size: 14px;
  display: inline-flex;
  align-items: center;
  padding: 4px 12px;

  .left-column {
    grid-area: left-column;
    align-self: center;
  }

  .top-row {
    grid-area: top-row;
  }

  .bottom-row {
    grid-area: bottom-row;
  }

  button {
    text-align: left;
    border: none;
    font-size: 14px;
    text-decoration: underline;
    color: $color-text-300;
    padding: 0;
    text-align: unset;
    padding-left: 12px;
    padding-right: 0px;
  }

  img {
    width: 16px;
    height: 16px;
    margin-right: 5px;
  }

  &:before {
    content: '';
    background: var(--background-gradient) border-box;
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    border-radius: 70px;
    border: 2px solid transparent;
    mask:
      linear-gradient(#fff 0, #fff 0) padding-box,
      linear-gradient(#fff 0, #fff 0);
    -webkit-mask:
      linear-gradient(#fff 0, #fff 0) padding-box,
      linear-gradient(#fff 0, #fff 0);
    -webkit-mask:
      linear-gradient(#fff 0 0) padding-box,
      linear-gradient(#fff 0 0);
    -webkit-mask-composite: xor;
    mask-composite: exclude;
  }
}
</style>
